public class MessageBuilder {

    private MessageState currentState = new Idling();
    
    private Message message = new Message();

    private Alphabet alphabet = new Alphabet();
    
    private Object lastPresented = null;
    
    private Presenter presenter = new Presenter();
    
    public synchronized void handleSelection() {
        MessageState nextState = currentState.handleSelection(this);
        currentState = nextState;
    }
    
    public synchronized void handleTimeout() {
        MessageState nextState = currentState.handleTimeout(this);
        currentState = nextState;
    }

    public Alphabet getAlphabet() {
        return alphabet;
    }

    public Message getMessage() {
        return message;
    }

    public Presenter getPresenter() {
        return presenter;
    }

    public void setLastPresented(Object o) {
        lastPresented = o;
    }

    public Object getLastPresented() {
        return lastPresented;
    }
}
